Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRCrossover.cs	(revision 17461)
@@ -38,5 +38,5 @@
     }
 
-    public abstract PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2);
+    public abstract PWR Cross(IRandom random, PWR parent1, PWR parent2);
 
     public override IOperation InstrumentedApply() {
@@ -44,5 +44,5 @@
 
       ChildParameter.ActualValue =
-        Cross(RandomParameter.ActualValue, parents[0] as PWREncoding, parents[1] as PWREncoding);
+        Cross(RandomParameter.ActualValue, parents[0] as PWR, parents[1] as PWR);
 
       return base.InstrumentedApply();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRGOXCrossover.cs	(revision 17461)
@@ -55,6 +55,6 @@
     }
 
-    public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
-      var result = new PWREncoding();
+    public static PWR Apply(IRandom random, PWR parent1, PWR parent2) {
+      var result = new PWR();
 
       var p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList();
@@ -87,5 +87,5 @@
     }
 
-    public override PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+    public override PWR Cross(IRandom random, PWR parent1, PWR parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Crossovers/PWRPPXCrossover.cs	(revision 17461)
@@ -41,6 +41,6 @@
     }
 
-    public static PWREncoding Apply(IRandom random, PWREncoding parent1, PWREncoding parent2) {
-      var result = new PWREncoding();
+    public static PWR Apply(IRandom random, PWR parent1, PWR parent2) {
+      var result = new PWR();
       var p1 = ((IntegerVector)(parent1.PermutationWithRepetition.Clone())).ToList();
       var p2 = ((IntegerVector)(parent2.PermutationWithRepetition.Clone())).ToList();
@@ -69,5 +69,5 @@
     }
 
-    public override PWREncoding Cross(IRandom random, PWREncoding parent1, PWREncoding parent2) {
+    public override PWR Cross(IRandom random, PWR parent1, PWR parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Decoder/PWRDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Decoder/PWRDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Decoder/PWRDecoder.cs	(revision 17461)
@@ -27,5 +27,5 @@
   [Item("PWRDecoder", "An item used to convert a PWR-individual into a generalized schedule.")]
   [StorableType("60D171BE-9704-40E1-9C63-0E56D95403CD")]
-  public class PWRDecoder : ScheduleDecoder<PWREncoding> {
+  public class PWRDecoder : ScheduleDecoder<PWR>, IPWROperator {
     [StorableConstructor]
     protected PWRDecoder(StorableConstructorFlag _) : base(_) { }
@@ -37,9 +37,9 @@
     }
 
-    public override Schedule DecodeSchedule(PWREncoding solution, ItemList<Job> jobData) {
+    public override Schedule DecodeSchedule(PWR solution, ItemList<Job> jobData) {
       return Decode(solution, jobData);
     }
 
-    public static Schedule Decode(PWREncoding solution, ItemList<Job> jobData) {
+    public static Schedule Decode(PWR solution, ItemList<Job> jobData) {
       var jobs = (ItemList<Job>)jobData.Clone();
       var resultingSchedule = new Schedule(jobs[0].Tasks.Count);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRInsertionManipulator.cs	(revision 17461)
@@ -40,5 +40,5 @@
     }
 
-    public static void Apply(IRandom random, PWREncoding individual) {
+    public static void Apply(IRandom random, PWR individual) {
       int cutIndex = random.Next(individual.PermutationWithRepetition.Length);
       int insertIndex = random.Next(individual.PermutationWithRepetition.Length);
@@ -55,5 +55,5 @@
     }
 
-    protected override void Manipulate(IRandom random, PWREncoding individual) {
+    protected override void Manipulate(IRandom random, PWR individual) {
       Apply(random, individual);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/Manipulators/PWRManipulator.cs	(revision 17461)
@@ -35,8 +35,8 @@
     public PWRManipulator() : base() { }
 
-    protected abstract void Manipulate(IRandom random, PWREncoding individual);
+    protected abstract void Manipulate(IRandom random, PWR individual);
 
     public override IOperation InstrumentedApply() {
-      var solution = ScheduleParameter.ActualValue as PWREncoding;
+      var solution = ScheduleParameter.ActualValue as PWR;
       if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type PWREncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWR.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWR.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWR.cs	(revision 17461)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Permutation With Repetition", "Represents a encoding for a standard JobShop Scheduling Problem.")]
+  [StorableType("31A66AC4-897D-4986-A6FC-DC301DC06278")]
+  public class PWR : Item, IScheduleSolution {
+
+    [Storable]
+    public IntegerVector PermutationWithRepetition { get; set; }
+
+    [StorableConstructor]
+    protected PWR(StorableConstructorFlag _) : base(_) { }
+    protected PWR(PWR original, Cloner cloner)
+      : base(original, cloner) {
+      this.PermutationWithRepetition = cloner.Clone(original.PermutationWithRepetition);
+    }
+    public PWR()
+      : base() {
+      PermutationWithRepetition = new IntegerVector();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PWR(this, cloner);
+    }
+
+    public PWR(int nrOfJobs, int nrOfResources, IRandom random)
+      : base() {
+      PermutationWithRepetition = new IntegerVector(nrOfJobs * nrOfResources);
+      int[] lookUpTable = new int[nrOfJobs];
+
+      for (int i = 0; i < PermutationWithRepetition.Length; i++) {
+        int newValue = random.Next(nrOfJobs);
+        while (lookUpTable[newValue] >= nrOfResources)
+          newValue = random.Next(nrOfJobs);
+
+        PermutationWithRepetition[i] = newValue;
+
+        lookUpTable[newValue]++;
+      }
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+      foreach (int i in PermutationWithRepetition) {
+        sb.Append(i + " ");
+      }
+      sb.Append("]");
+
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PWRRandomCreator.cs	(revision 17461)
@@ -29,5 +29,5 @@
   [Item("PermutationWithRepetitionRandomCreator", "Creates PWR-individuals at random.")]
   [StorableType("6E753916-C0FD-4585-B6A6-47FD66ED098F")]
-  public class PWRRandomCreator : ScheduleCreator<PWREncoding>, IStochasticOperator {
+  public class PWRRandomCreator : ScheduleCreator<PWR>, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
@@ -47,9 +47,9 @@
     }
 
-    public static PWREncoding Apply(int jobs, int resources, IRandom random) {
-      return new PWREncoding(jobs, resources, random);
+    public static PWR Apply(int jobs, int resources, IRandom random) {
+      return new PWR(jobs, resources, random);
     }
 
-    protected override PWREncoding CreateSolution() {
+    protected override PWR CreateSolution() {
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PermutationWithRepetition/PermutationWithRepetitionEncoding.cs	(revision 17461)
@@ -32,5 +32,5 @@
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   [StorableType("468EF506-0749-469B-B9B9-36655AA0178D")]
-  public sealed class PermutationWithRepetitionEncoding : ScheduleEncoding<PWREncoding> {
+  public sealed class PermutationWithRepetitionEncoding : ScheduleEncoding<PWR> {
     [StorableConstructor]
     private PermutationWithRepetitionEncoding(StorableConstructorFlag _) : base(_) { }
@@ -41,5 +41,5 @@
 
     public PermutationWithRepetitionEncoding()
-      : base() {
+      : base("PWR") {
       SolutionCreator = new PWRRandomCreator();
       Decoder = new PWRDecoder();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVCrossover.cs	(revision 17461)
@@ -34,10 +34,10 @@
     public PRVCrossover() : base() { }
 
-    public abstract PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2);
+    public abstract PRV Cross(IRandom random, PRV parent1, PRV parent2);
 
     public override IOperation InstrumentedApply() {
       var parents = ParentsParameter.ActualValue;
       ChildParameter.ActualValue =
-        Cross(RandomParameter.ActualValue, parents[0] as PRVEncoding, parents[1] as PRVEncoding);
+        Cross(RandomParameter.ActualValue, parents[0] as PRV, parents[1] as PRV);
       return base.InstrumentedApply();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVDiscreteCrossover.cs	(revision 17461)
@@ -39,11 +39,11 @@
     }
 
-    public static PRVEncoding Apply(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public static PRV Apply(IRandom random, PRV parent1, PRV parent2) {
       var randomSeed = random.Next();
       var integerVector = DiscreteCrossover.Apply(random, new ItemArray<IntegerVector>(new[] { parent1.PriorityRulesVector, parent2.PriorityRulesVector }));
-      return new PRVEncoding(integerVector, randomSeed);
+      return new PRV(integerVector, randomSeed);
     }
 
-    public override PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public override PRV Cross(IRandom random, PRV parent1, PRV parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Crossovers/PRVSinglePointCrossover.cs	(revision 17461)
@@ -39,11 +39,11 @@
     }
 
-    public static PRVEncoding Apply(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public static PRV Apply(IRandom random, PRV parent1, PRV parent2) {
       var randomSeed = random.Next();
       var integerVector = SinglePointCrossover.Apply(random, parent1.PriorityRulesVector, parent2.PriorityRulesVector);
-      return new PRVEncoding(integerVector, randomSeed);
+      return new PRV(integerVector, randomSeed);
     }
 
-    public override PRVEncoding Cross(IRandom random, PRVEncoding parent1, PRVEncoding parent2) {
+    public override PRV Cross(IRandom random, PRV parent1, PRV parent2) {
       return Apply(random, parent1, parent2);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Decoder/PRVDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Decoder/PRVDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Decoder/PRVDecoder.cs	(revision 17461)
@@ -29,5 +29,5 @@
   [Item("JobSequencingMatrixDecoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequencing Matrix.")]
   [StorableType("2D059957-AC7C-4B33-BADE-96706AEBAF29")]
-  public class PRVDecoder : ScheduleDecoder<PRVEncoding> {
+  public class PRVDecoder : ScheduleDecoder<PRV>, IPRVOperator {
     #region Priority Rules
     //smallest number of remaining tasks
@@ -187,9 +187,9 @@
     }
 
-    public override Schedule DecodeSchedule(PRVEncoding encoding, ItemList<Job> jobData) {
+    public override Schedule DecodeSchedule(PRV encoding, ItemList<Job> jobData) {
       return Decode(encoding, jobData);
     }
 
-    public static Schedule Decode(PRVEncoding solution, ItemList<Job> jobData) {
+    public static Schedule Decode(PRV solution, ItemList<Job> jobData) {
       var random = new FastRandom(solution.RandomSeed);
       var jobs = (ItemList<Job>)jobData.Clone();
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVManipulator.cs	(revision 17461)
@@ -46,8 +46,8 @@
     }
 
-    protected abstract void Manipulate(IRandom random, PRVEncoding individual, int numberOfRules);
+    protected abstract void Manipulate(IRandom random, PRV individual, int numberOfRules);
 
     public override IOperation InstrumentedApply() {
-      var solution = ScheduleParameter.ActualValue as PRVEncoding;
+      var solution = ScheduleParameter.ActualValue as PRV;
       if (solution == null) throw new InvalidOperationException("ScheduleEncoding was not found or is not of type PRVEncoding.");
       Manipulate(RandomParameter.ActualValue, solution, NumberOfRulesParameter.ActualValue.Value);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/Manipulators/PRVUniformOnePositionManipulator.cs	(revision 17461)
@@ -40,9 +40,9 @@
     }
 
-    public static void Apply(IRandom random, PRVEncoding individual, int numberOfRules) {
+    public static void Apply(IRandom random, PRV individual, int numberOfRules) {
       UniformOnePositionManipulator.Apply(random, individual.PriorityRulesVector, new IntMatrix(new int[,] { { 0, numberOfRules } }));
     }
 
-    protected override void Manipulate(IRandom random, PRVEncoding individual, int numberOfRules) {
+    protected override void Manipulate(IRandom random, PRV individual, int numberOfRules) {
       Apply(random, individual, numberOfRules);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRV.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRV.cs	(revision 17461)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRV.cs	(revision 17461)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Priority Rules Vector", "Represents an encoding for a Scheduling Problem.")]
+  [StorableType("D42AC200-1F87-451E-A953-803EF33BE953")]
+  public class PRV : Item, IScheduleSolution {
+    [Storable]
+    public IntegerVector PriorityRulesVector { get; private set; }
+    [Storable]
+    public int RandomSeed { get; private set; }
+
+    [StorableConstructor]
+    protected PRV(StorableConstructorFlag _) : base(_) { }
+    protected PRV(PRV original, Cloner cloner)
+      : base(original, cloner) {
+      this.PriorityRulesVector = cloner.Clone(original.PriorityRulesVector);
+      this.RandomSeed = original.RandomSeed;
+    }
+
+    public PRV(IntegerVector iv, int randomSeed)
+      : base() {
+      this.RandomSeed = randomSeed;
+      this.PriorityRulesVector = (IntegerVector)iv.Clone();
+    }
+    public PRV(int length, IRandom random, int min, int max)
+      : base() {
+      this.RandomSeed = random.Next();
+      this.PriorityRulesVector = new IntegerVector(length, random, min, max);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PRV(this, cloner);
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+
+      foreach (int i in PriorityRulesVector) {
+        sb.Append(i + " ");
+      }
+
+      sb.Append("]");
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PRVRandomCreator.cs	(revision 17461)
@@ -29,5 +29,5 @@
   [Item("PriorityRulesRandomCreator", "Creator class used to create PRV encoding objects for scheduling problems.")]
   [StorableType("5FF2A11E-86F9-4A8B-8E1C-713D6801506C")]
-  public class PRVRandomCreator : ScheduleCreator<PRVEncoding>, IStochasticOperator {
+  public class PRVRandomCreator : ScheduleCreator<PRV>, IStochasticOperator {
 
     [Storable]
@@ -54,9 +54,9 @@
     }
 
-    public static PRVEncoding Apply(int jobs, int resources, IRandom random, int nrOfRules) {
-      return new PRVEncoding(jobs * resources, random, 0, nrOfRules);
+    public static PRV Apply(int jobs, int resources, IRandom random, int nrOfRules) {
+      return new PRV(jobs * resources, random, 0, nrOfRules);
     }
 
-    protected override PRVEncoding CreateSolution() {
+    protected override PRV CreateSolution() {
       return Apply(JobsParameter.ActualValue.Value, ResourcesParameter.ActualValue.Value, RandomParameter.ActualValue, NrOfRules);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/PriorityRulesVector/PriorityRulesVectorEncoding.cs	(revision 17461)
@@ -34,5 +34,5 @@
 namespace HeuristicLab.Encodings.ScheduleEncoding {
   [StorableType("9C419EE5-F3A8-4F06-8263-7D37D3AE1C72")]
-  public sealed class PriorityRulesVectorEncoding : ScheduleEncoding<PRVEncoding> {
+  public sealed class PriorityRulesVectorEncoding : ScheduleEncoding<PRV> {
 
     private IFixedValueParameter<IntValue> numberOfRulesParameter;
@@ -60,5 +60,5 @@
 
     public PriorityRulesVectorEncoding()
-      : base() {
+      : base("PRV") {
       //TODO change to meaningful value
       numberOfRulesParameter = new FixedValueParameter<IntValue>(Name + ".NumberOfRules", new IntValue(10));
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCreator.cs	(revision 17461)
@@ -31,5 +31,5 @@
   [StorableType("3DDA1485-4518-4F1D-A475-795FFE63C98E")]
   public abstract class ScheduleCreator<TSchedule> : InstrumentedOperator, IScheduleCreator<TSchedule>
-  where TSchedule : class,ISchedule {
+  where TSchedule : class,IScheduleSolution {
 
     public ILookupParameter<TSchedule> ScheduleParameter {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleCrossover.cs	(revision 17461)
@@ -32,9 +32,9 @@
   public abstract class ScheduleCrossover : InstrumentedOperator, IScheduleCrossover, IStochasticOperator {
 
-    public ILookupParameter<ISchedule> ChildParameter {
-      get { return (ILookupParameter<ISchedule>)Parameters["Child"]; }
+    public ILookupParameter<IScheduleSolution> ChildParameter {
+      get { return (ILookupParameter<IScheduleSolution>)Parameters["Child"]; }
     }
-    public IScopeTreeLookupParameter<ISchedule> ParentsParameter {
-      get { return (IScopeTreeLookupParameter<ISchedule>)Parameters["Parents"]; }
+    public IScopeTreeLookupParameter<IScheduleSolution> ParentsParameter {
+      get { return (IScopeTreeLookupParameter<IScheduleSolution>)Parameters["Parents"]; }
     }
     public ILookupParameter<IRandom> RandomParameter {
@@ -48,7 +48,7 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new LookupParameter<ISchedule>("Child", "The child solution resulting from the crossover."));
+      Parameters.Add(new LookupParameter<IScheduleSolution>("Child", "The child solution resulting from the crossover."));
       ChildParameter.ActualName = "Schedule";
-      Parameters.Add(new ScopeTreeLookupParameter<ISchedule>("Parents", "The parent solution which should be crossed."));
+      Parameters.Add(new ScopeTreeLookupParameter<IScheduleSolution>("Parents", "The parent solution which should be crossed."));
       ParentsParameter.ActualName = "Schedule";
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleDecoder.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleDecoder.cs	(revision 17460)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleDecoder.cs	(revision 17461)
@@ -31,8 +31,8 @@
   [StorableType("57A68F4B-4B35-4DB4-9B5E-D5154DD46E45")]
   public abstract class ScheduleDecoder<TSchedule> : SingleSuccessorOperator, IScheduleDecoder<TSchedule>
-  where TSchedule : class, ISchedule {
+  where TSchedule : class, IScheduleSolution {
 
-    public ILookupParameter<ISchedule> ScheduleEncodingParameter {
-      get { return (ILookupParameter<ISchedule>)Parameters["EncodedSchedule"]; }
+    public ILookupParameter<IScheduleSolution> ScheduleEncodingParameter {
+      get { return (ILookupParameter<IScheduleSolution>)Parameters["EncodedSchedule"]; }
     }
     public ILookupParameter<Schedule> ScheduleParameter {
@@ -48,10 +48,10 @@
     public ScheduleDecoder()
       : base() {
-      Parameters.Add(new LookupParameter<ISchedule>("EncodedSchedule", "The new scheduling solution represented as encoding."));
+      Parameters.Add(new LookupParameter<IScheduleSolution>("EncodedSchedule", "The new scheduling solution represented as encoding."));
       Parameters.Add(new LookupParameter<Schedule>("Schedule", "The decoded scheduling solution represented as generalized schedule."));
       Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the JSSP - Instance."));
     }
 
-    public Schedule DecodeSchedule(ISchedule schedule, ItemList<Job> jobData) {
+    public Schedule DecodeSchedule(IScheduleSolution schedule, ItemList<Job> jobData) {
       TSchedule solution = schedule as TSchedule;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type " + typeof(TSchedule).GetPrettyName());
